#if !defined(_ADATA_ADMXRC3_API_PLATFORM_H)
#define _ADATA_ADMXRC3_API_PLATFORM_H

/*
** File: platform.h  
** Project: ADMXRC3 API module library
** Purpose: Interface to Linux-specific functions for ADMXRC3 API module library
**
** (C) Copyright Alpha Data 2009-2010
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <wchar.h>
#include <ctype.h>
#include <linux/ioctl.h>

typedef int bool_t;
typedef FILE* portable_file_t;
#define INVALID_PORTABLE_FILE (NULL)

#define ADMXRC3_HAS_USER_EVENT_HANDLE (0)

#define ADMXRC3_HAS_WCHAR_SUPPORT (1)

#include <admxrc3/platform.h>
#include <admxrc3/status.h>
#include <admxrc3/types.h>
#include <admxrc3/ticket.h>

#define TRUE  (1)
#define FALSE (0)

extern ADMXRC3_STATUS
admxrc3OpenDevice(
  unsigned int index,
  int bUnprivileged,
  ADMXRC3_HANDLE* phDevice);

extern ADMXRC3_STATUS
admxrc3CloseDevice(
  ADMXRC3_HANDLE hDevice);

extern ADMXRC3_STATUS
admxrc3Ioctl(
  ADMXRC3_HANDLE hDevice,
  unsigned int code,
  void* pIoctl,
  unsigned int sizeIn,
  unsigned int sizeOut);

extern ADMXRC3_STATUS
admxrc3IoctlNonBlock(
  ADMXRC3_HANDLE hDevice,
  ADMXRC3_TICKET* pTicket,
  unsigned int code,
  void* pIoctl,
  unsigned int sizeIn,
  unsigned int sizeOut);

ADMXRC3_STATUS
admxrc3FinishNonBlock(
  ADMXRC3_HANDLE hAdmxrc3,
  ADMXRC3_TICKET* pTicket,
  bool_t bWait,
  void* pIoctl,
  unsigned int sizeOut);

extern ADMXRC3_STATUS
admxrc3IoctlCancel(
  ADMXRC3_HANDLE hDevice);

extern ADMXRC3_STATUS
admxrc3MapRegion(
  ADMXRC3_HANDLE hCard,
  unsigned int windowIndex,
  uint64_t offset,
  uint64_t length,
  void** ppVirtualBase);

extern ADMXRC3_STATUS
admxrc3UnmapRegion(
  ADMXRC3_HANDLE hCard,
  const void* pVirtualBase);

#define portableFormatStringA1 snprintf
#define portableFormatStringA2 snprintf
#define portableFormatStringA3 snprintf
#define portableFormatStringA4 snprintf

#endif
