/*
** File: admxrc6t1.h  
** Project: ADM-XRC core driver
** Purpose: Definitions specific to ADM-XRC-6T1.
**
** (C) Copyright Alpha Data 2009-2010
*/

#ifndef _ADATA_CORE_ADMXRC6T1_H
#define _ADATA_CORE_ADMXRC6T1_H

#include <df.h>
#include "adb3.h"
#include "admxrc6tl.h"
#include "admxrc6tx.h"

#define ADMXRC6T1_NUM_DMA_CHANNEL (4U)

/* Always LITTLE ENDIAN when stored in hardware */
#pragma pack(1)
typedef struct _VpdAdmxrc6t1Rev0 {
	uint16_t version;       /* Revision of this structure (0) */
	uint16_t length;        /* Length of this structure including checksum */
	uint32_t serial;
	uint32_t modifications;
	uint32_t lclkRef;
	uint32_t mgtRef;
	struct {
		uint16_t speed;       /* In units of 100 kHz */
		uint8_t	 order;       /* Log base 2 of size in words */
    uint8_t  _reserved1;
    uint16_t link;        /* Byte offset in VPD of extended info */
    uint16_t _reserved2;
	} sdram[4];
  struct {
    uint8_t  stepping[8];
    uint8_t  speedGrade[4];
    uint16_t device;
    uint8_t  tempGrade;
    uint8_t  _reserved1;
  } fpga;
	uint8_t  pcbRev;
	uint8_t  cpldRev;
  uint8_t  _reserved1;
  uint8_t  checksum;      /* This MUST ALWAYS be the last member in the struct */
} VpdAdmxrc6t1Rev0;
#pragma pack()

/* Values for VpdAdmxrc6t1Rev0::modifications */
#define ADMXRC6T1_VPD_MOD_NOTFITTED_XMC_P16 ADMXRC6TL_VPD_MOD_NOTFITTED_XMC_P16
#define ADMXRC6T1_VPD_MOD_NOTFITTED_XMC_PN4 ADMXRC6TL_VPD_MOD_NOTFITTED_XMC_P16

/* Values for VpdAdmxrc6t1Rev0::fpga::tempGrade */
#define ADMXRC6T1_VPD_TEMPGRADE_COMMERCIAL  ADMXRC6TL_VPD_TEMPGRADE_COMMERCIAL
#define ADMXRC6T1_VPD_TEMPGRADE_INDUSTRIAL  ADMXRC6TL_VPD_TEMPGRADE_INDUSTRIAL

#endif
